%%% Filename : p_printcmd.pl
%%% Date     : 02.04.2012
%%% Contents : prints the rules on the command-line
%%% Author   : Lara Katharina Spendier <lara@logic.at>


%% printrule(+Rule)
%%	prints the rule on the commandline; 
%% 	Rule ... [Premises, Conclusion]
printrule([]).
printrule([[P, C]|T]) :-
	nl, nl, printpremises(P),
	nl,write('-----------------------------'),nl,
	printconclusion(C),
	printrule(T).

%% printpremises(+Premise)
%%	prints the premises of the rule
printpremises([]) :-
	write(' ').
printpremises([P|T]) :-
	printpremise(P),
	printpremises(T).

%% printpremise(+Premise)
%%	prints one premise on the command line
printpremise([A, S]) :-
	printantecedent(A),
	write('=>'),
	printsuccedent(S).

%% printconclusion(+Conclusion, Class)
%%	prints the conclusion of the rule
printconclusion([A, S]) :-
	printantecedent(A),
	write('=>'),
	printsuccedent(S).

%% printantecedent(+Antecedent)
%%	prints the antecedent
printantecedent([]).
printantecedent([H|[]]) :-
	writef('%p ', [H]).
printantecedent([H|T]) :-
	writef('%p,', [H]),
	printantecedent(T).

%% printsuccedent(+Succedent)
%%	prints the succedent
printsuccedent([]).
printsuccedent([H|[]]) :-
	writef('%p      ', [H]).
printsuccedent([H|T]) :-
	writef('%p,', [H]),
	printsuccedent(T).
