%%% Filename : p_unaryrules.pl
%%% Date     : 13.04.2012
%%% Contents : the various rules for the two unary connectives
%%% Author   : Lara Katharina Spendier <lara@logic.at>

%% isUnaryRule(ConnectiveNr, Connective, Rule).
%% 1 .. negation right
isUnaryRule(1, Connective, Rule) :-
	( Connective = '*1' ->
  	  Rule = [ [[[[p1], []]], [[],['*1' p1]]]]
        ; Rule = [ [[[[p1], []]], [[],['*2' p1]]]]).

%% 2 .. negation left
isUnaryRule(2, Connective, Rule) :-
	( Connective = '*1' ->
  	  Rule = [ [[[[], [p1]]], [['*1' p1], []]]]
        ; Rule = [ [[[[], [p1]]], [['*2' p1], []]]]).

%% 10 ... circle right & left
isUnaryRule(10, _, Rule) :-
	Rule = [ [[[[], [p1]], [[], ['*1' p1]]], [['*2' p1],[]]],
	 [[[[p1, '*1' p1], []]], [[],['*2' p1]] ]].

%% 11 .. test left
isUnaryRule(11, Connective, Rule) :-
	( Connective = '*1' ->
  	  Rule = [ [[[[], [p1, '*1' p1]]], [['*1' p1], []]]]
        ; Rule = [ [[[[], [p1, '*2', p1]]], [['*2' p1], []]]]).

%% 12 .. test right
isUnaryRule(12, Connective, Rule) :-
	( Connective = '*1' ->
  	  Rule = [ [[[[], ['*1' p1, p1]]], [['*1' p1], []]]]
        ; Rule = [ [[[[], ['*2' p1, p1]]], [['*2' p1], []]]]).

