\newtheorem{theorem}{Theorem}
\newtheorem{lemma}[theorem]{Lemma}
\newtheorem{corollary}[theorem]{Corollary}
\newtheorem{proposition}[theorem]{Proposition}
\newtheorem{conjecture}[theorem]{Conjecture}
\newtheorem{definition}[theorem]{Definition}
\newtheorem{example}[theorem]{Example}
\newtheorem{proof}[theorem]{Proof}

\newcommand{\ra}{\rightarrow}
\newcommand{\Ra}{\Rightarrow}
\newcommand{\La}{\Leftarrow}
\newcommand{\la}{\leftarrow}
\newcommand{\LR}{\Leftrightarrow}
\newcommand{\hh}{\ \mid\ }

\def\TVFLeP{$1\mid\bot$}
\def\TVFLeN{$0\mid\top$}
\def\TVFLewP{$1$}
\def\TVFLewN{$0$}
\def\TVTexte{(unit), $\bot$ (false), $\top$ (true) }
\def\TVTextw{\ }

\def\EquivalenceSeq{
The notion of proof in \textbf{FLe} is defined as usual. Let $R$ be a 
set of rules. If there is a proof in \textbf{FLe} extended with $R$
(\textbf{FLe} $+ R$, for short) of a sequent $S_0$ from a set of sequents
$\mathcal{S}$, we say that $S_0$ is derivable from $\mathcal{S}$ in 
\textbf{FLe}$+R$ and write $\mathcal{S} \vdash_{\textbf{Fle}+R} S_0$ . 
We write $\vdash_{\textbf{Fle}+R} \alpha$ if $\emptyset \vdash_{\textbf{Fle}+R} \Ra\alpha$.

Two rules $(r_0)$ and $(r_1)$ are equivalent (in \textbf{\NameBaseCalculus}) 
if the relations $\vdash_{\textbf{\NameBaseCalculus}+(r_0)}$ and 
$\vdash_{\textbf{\NameBaseCalculus}+(r_1)}$ coincide. 
}

\def\EquivalenceHSeq{
\begin{definition}
A \emph{hypersequent} $G$ is a multiset $S_1\hh\cdots\hh S_n$ where each $S_i$
for $i=1,\ldots,n$ is a sequent, called a \emph{component} of the hypersequent.
A hypersequent is called \emph{single-conclusion} if all its components are
single-conclusion and it is called \emph{multiple-conclusion}, otherwise.
\end{definition}

The symbol ``$\hh$'' is intended to denote disjunction at the meta-level.

As in the case of sequent calculus, the hypersequent calculus consists of 
initial axioms, logical rules, the cut-rule and structural rules. Initial axioms, 
logical rules and the cut-rule are essentially the same as in the sequent calculus. 
The only difference is that a (possibly empty) side hypersequent $G$ may occur in 
hypersequents. The structural rules are divided into two groups: \emph{internal}
structural rules and \emph{external} structural rules. The former are applied 
to formulas within sequents. External rules instead manipulate the
components of a hypersequent and therefore increase the expressive power of hypersequent
calculus with respect to sequent calculus.

The notion of proof in \textbf{HFLew} is defined as usual. Let $R$ be a 
set of rules. If there is a proof in \textbf{HFLew} extended with $R$
(\textbf{HFLew}$+ R$, for short) of a sequent $S_0$ from a set of sequents
$\mathcal{S}$, we say that $S_0$ is derivable from $\mathcal{S}$ in 
\textbf{HFLew}$+R$ and write $\mathcal{S} \vdash_{\textbf{HFLew}+R} S_0$ . 
We write $\vdash_{\textbf{HFLew}+R} \alpha$ if $\emptyset \vdash_{\textbf{HFLew}+R} \Ra\alpha$.

Two hypersequent rules $(hr_0)$ and $(hr_1)$ are equivalent (in 
\textbf{\NameBaseCalculus}) if the relations 
$\vdash_{\textbf{\NameBaseCalculus}+(hr_0)}$ and 
$\vdash_{\textbf{\NameBaseCalculus}+(hr_1)}$ coincide when restricted to sequents.
}

\def\FullLambekSeq{Full Lambek calculus with exchange (\textbf{FLe})}
\def\FullLambekHSeq{Full Lambek calculus with exchange and weakening (\textbf{FLew})}

\def\CalculusFLe{
\begin{tabular}{ll} \hline \\
    \emph{Initial Rules} & \\\\
    \AxiomC{}
	\RightLabel{\emph{$(init)$}}
	\UnaryInfC{$A \Ra A$}
	\DisplayProof
	&\\\\
	\AxiomC{}
	\RightLabel{\emph{$(0,l)$}}
	\UnaryInfC{$0 \Ra$}
	\DisplayProof
    \hspace{0.3cm} 
    \AxiomC{}
	\RightLabel{\emph{$(1,r)$}}
	\UnaryInfC{$\Ra 1$}
	\DisplayProof
	&
	\AxiomC{}
	\RightLabel{\emph{$(\top,r)$}}
	\UnaryInfC{$\Gamma \Ra \top$}
	\DisplayProof
	\hspace{0.3cm} 
	\AxiomC{}
	\RightLabel{\emph{$(\bot,l)$}}
	\UnaryInfC{$\bot,\Gamma \Ra \Pi$}
	\DisplayProof
	\\\\
    \emph{Cut Rule} &\\\\
    \AxiomC{$\Gamma \Ra A$ } 
    \AxiomC{$A, \Sigma \Ra \Pi$ } 
    \RightLabel{$(cut)$}
    \BinaryInfC{$\Sigma, \Gamma \Ra \Pi$} 
    \DisplayProof 
    &
	\\\\
	\emph{Logical Rules}  & \\\\
	\AxiomC{$\Gamma, A \Ra B$}
	\RightLabel{\emph{($\ra$, r)}}
	\UnaryInfC{$\Gamma \Ra A \ra B$}
	\DisplayProof
	&
	\AxiomC{$\Gamma\Ra A$}
	\AxiomC{$B,\Gamma\Ra\Pi$}
	\RightLabel{\emph{($\ra$, l)}}
	\BinaryInfC{$\Gamma,A\ra B\Ra\Pi$}
	\DisplayProof
	\\\\
	\AxiomC{$\Gamma \Ra A$}
	\AxiomC{$\Gamma \Ra B$}
	\RightLabel{\emph{($\land$, r)}}
	\BinaryInfC{$\Gamma \Ra A \land B$}
	\DisplayProof
	& 
	\AxiomC{$\Gamma, A_i \Ra \Pi$}
	\RightLabel{\emph{($\land_i$, l)$_{i=1,2}$}}
	\UnaryInfC{$\Gamma, A_1 \land A_2 \Ra \Pi$}
	\DisplayProof
	\\\\
	\AxiomC{$\Gamma \Ra A_i$}
	\RightLabel{\emph{($\lor_i$, r)$_{i=1,2}$}}
	\UnaryInfC{$\Gamma \Ra A_1 \lor A_2$}
	\DisplayProof
	& 
	\AxiomC{$\Gamma, A \Ra \Pi$}
	\AxiomC{$\Gamma, B \Ra \Pi$}
	\RightLabel{\emph{($\lor$, l)}}
	\BinaryInfC{$\Gamma, A \lor B \Ra \Pi$}
	\DisplayProof
	\\\\
	\AxiomC{$\Gamma \Ra A$}
	\AxiomC{$\Gamma \Ra B$}
	\RightLabel{\emph{($\cdot$, r)}}
	\BinaryInfC{$\Gamma \Ra A \cdot B$}
	\DisplayProof
	& 
	\AxiomC{$\Gamma, A, B \Ra \Pi$}
	\RightLabel{\emph{($\cdot$, l)}}
	\UnaryInfC{$\Gamma, A \cdot B \Ra \Pi$}
	\DisplayProof
	\\\\ 
	\AxiomC{$\Gamma\Ra $}
	\RightLabel{\emph{($0$, r)}}
	\UnaryInfC{$\Gamma \Ra 0$}
	\DisplayProof
	& 
	\AxiomC{$\Gamma \Ra \Pi$}
	\RightLabel{\emph{($1$, l)}}
	\UnaryInfC{$\Gamma, 1\Ra \Pi$}
	\DisplayProof
	\\\\
	\hline
  \end{tabular}}
  
\def\CalculusHFLew{
\begin{tabular}{ll} \hline \\
    \emph{Initial Rules} & \\\\
    \AxiomC{}
	\RightLabel{\emph{$(init)$}}
	\UnaryInfC{$G\hh A \Ra A$}
	\DisplayProof
	&
%	\\\\
	\AxiomC{}
	\RightLabel{\emph{$(0,l)$}}
	\UnaryInfC{$G\hh 0 \Ra$}
	\DisplayProof
    \hspace{0.3cm} 
    \AxiomC{}
	\RightLabel{\emph{$(1,r)$}}
	\UnaryInfC{$G\hh \Ra 1$}
	\DisplayProof
%	&
%	\AxiomC{}
%	\RightLabel{\emph{$(\top,r)$}}
%	\UnaryInfC{$G\hh \Gamma \Ra \top$}
%	\DisplayProof
%	\hspace{0.3cm} 
%	\AxiomC{}
%	\RightLabel{\emph{$(\bot,l)$}}
%	\UnaryInfC{$G\hh \bot,\Gamma \Ra \Pi$}
%	\DisplayProof
	\\\\
    \emph{Cut Rule} & \emph{Internal Structural Rules}\\\\
    \AxiomC{$G\hh \Gamma \Ra A$ } 
    \AxiomC{$G\hh A, \Sigma \Ra \Pi$ } 
    \RightLabel{$(cut)$}
    \BinaryInfC{$G\hh \Sigma, \Gamma \Ra \Pi$} 
    \DisplayProof 
    &
    \AxiomC{$G\hh \Gamma \Ra \Pi$ } 
    \RightLabel{$(w,l)$}
    \UnaryInfC{$G\hh \Gamma, A \Ra \Pi$} 
    \DisplayProof 
	\\\\
	\emph{External Structural Rules} & \\\\
    \AxiomC{$G$} 
    \RightLabel{$(EW)$}
    \UnaryInfC{$G\hh \Gamma \Ra \Pi$} 
    \DisplayProof 
    &
    \AxiomC{$G\hh\Gamma\Ra\Pi\hh\Gamma\Ra\Pi$} 
    \RightLabel{$(EC)$}
    \UnaryInfC{$G\hh\Gamma \Ra \Pi$} 
    \DisplayProof 
    \\\\
	\emph{Logical Rules}  & \\\\
	\AxiomC{$G\hh \Gamma, A \Ra B$}
	\RightLabel{\emph{($\ra$, r)}}
	\UnaryInfC{$G\hh \Gamma \Ra A \ra B$}
	\DisplayProof
	&
	\AxiomC{$G\hh \Gamma\Ra A$}
	\AxiomC{$G\hh B,\Gamma\Ra\Pi$}
	\RightLabel{\emph{($\ra$, l)}}
	\BinaryInfC{$G\hh \Gamma,A\ra B\Ra\Pi$}
	\DisplayProof
	\\\\
	\AxiomC{$G\hh \Gamma \Ra A$}
	\AxiomC{$G\hh \Gamma \Ra B$}
	\RightLabel{\emph{($\land$, r)}}
	\BinaryInfC{$G\hh \Gamma \Ra A \land B$}
	\DisplayProof
	& 
	\AxiomC{$G\hh \Gamma, A_i \Ra \Pi$}
	\RightLabel{\emph{($\land_i$, l)$_{i=1,2}$}}
	\UnaryInfC{$G\hh \Gamma, A_1 \land A_2 \Ra \Pi$}
	\DisplayProof
	\\\\
	\AxiomC{$G\hh \Gamma \Ra A_i$}
	\RightLabel{\emph{($\lor_i$, r)$_{i=1,2}$}}
	\UnaryInfC{$G\hh \Gamma \Ra A_1 \lor A_2$}
	\DisplayProof
	& 
	\AxiomC{$G\hh \Gamma, A \Ra \Pi$}
	\AxiomC{$G\hh \Gamma, B \Ra \Pi$}
	\RightLabel{\emph{($\lor$, l)}}
	\BinaryInfC{$G\hh \Gamma, A \lor B \Ra \Pi$}
	\DisplayProof
	\\\\
	\AxiomC{$G\hh \Gamma \Ra A$}
	\AxiomC{$G\hh \Gamma \Ra B$}
	\RightLabel{\emph{($\cdot$, r)}}
	\BinaryInfC{$G\hh \Gamma \Ra A \cdot B$}
	\DisplayProof
	& 
	\AxiomC{$G\hh \Gamma, A, B \Ra \Pi$}
	\RightLabel{\emph{($\cdot$, l)}}
	\UnaryInfC{$G\hh \Gamma, A \cdot B \Ra \Pi$}
	\DisplayProof
	\\\\ 
	\AxiomC{$G\hh \Gamma\Ra $}
	\RightLabel{\emph{($0$, r)}}
	\UnaryInfC{$G\hh \Gamma \Ra 0$}
	\DisplayProof
	& 
	\AxiomC{$G\hh \Gamma \Ra \Pi$}
	\RightLabel{\emph{($1$, l)}}
	\UnaryInfC{$G\hh \Gamma, 1\Ra \Pi$}
	\DisplayProof
	\\\\
	\hline
  \end{tabular}}